/**************************************************************
 Programa: GMatrixCmexFunction.c
**************************************************************/

#include "mex.h"
#include <windows.h>
#include <math.h>

#define GMATRIX_CMEX 
#include "..\..\GMatrix.h"

void Calcular_Ainv(pAinv,pA)
{
	PGMATRIX_INVERSE_COPY(pAinv, pA);
}

void Calcular_Apinv(PGMATRIX pApinv, PGMATRIX pA)
{
	PGMATRIX pMatDummy;

	pMatDummy = PGMATRIX_ALLOC(pA->Nr,pA->Nc);
	PGMATRIX_PSEUDOINVERSE(pApinv, pA, pMatDummy);
	PGMATRIX_FREE(pMatDummy);
}

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	PGMATRIX pA,pAinv,pApinv;

	/* Verificar as entradas */
	if(nrhs!=1){
		mexErrMsgTxt("Uma entrada requerida.");
		}
	if(nlhs!=2){
		mexErrMsgTxt("Duas saidas requeridas.");
		}

	/* Variaveis de entrada */
	pA = PGMATRIX_ALLOC_FROM_MXARRAY(prhs[0]);
	if(pA->Nr != pA->Nc){
		PGMATRIX_FREE(pA);
		mexErrMsgTxt("A matriz A deve ser quadrada.");
	}

	/* Alocao das matrizes Ainv e Apinv */
	pAinv = PGMATRIX_ALLOC(pA->Nr,pA->Nc);
	pApinv = PGMATRIX_ALLOC(pA->Nr,pA->Nc);

	/* Funes principais */
	Calcular_Ainv(pAinv,pA);
    Calcular_Apinv(pApinv,pA);

	/* Variaveis de saida */
	plhs[0] = PGMATRIX_COPY_TO_MXARRAY(pAinv);
	plhs[1] = PGMATRIX_COPY_TO_MXARRAY(pApinv);

	/* Free memory */
	PGMATRIX_FREE(pA);
	PGMATRIX_FREE(pAinv);
	PGMATRIX_FREE(pApinv);

}
